;-- TIME_STAMP   2018-02-01 14:35:38   v 0.1

#Region    ;************ Includes ************
#include-once
#Include <ButtonConstants.au3>
#Include <StaticConstants.au3>
#Include <EditConstants.au3>
#Include <Date.au3>
#include <GUIConstantsEx.au3>
#include <Misc.au3>
#include <NamedPipes.au3>
#EndRegion ;************ Includes ************

Opt('MustDeclareVars', 1)

Global $g_idLabelStatus, $g_idMemo, $g_iDiffTime = 1000 * 10 ; 1000 * 60 * 30 = 30 Minuten --> $g_iDiffTime = 1800000

Global $g_aColors = [0x6495ED, 0x483D8B, 0x7FFF00, 0x006400, 0x9999FF, 0x10109B]

Global $g_hTimer, $g_sTime, $g_iHour, $g_iMins, $g_iSecs, $g_iMiliSecs, $g_iTicks

Global $g_iDEBUG = 0

If $g_iDEBUG Then
	ConsoleWrite(_GetCmdLine() & @CRLF)
	ConsoleWrite(_GetCmdLine(False) & @CRLF)
	ConsoleWrite(60 * 1000 * 30 & @CRLF)
	Exit
EndIf

_Messwerte()

Func _Messwerte()
	Local $aInputsMesswerte[5], $hGui, $sTitle = 'Messwerte' ; Programmname (für _Singleton)
	Local $sPipeName = "\\.\pipe\virtual01@" & @ComputerName, $hPipe, $bData, $sData, $tDataBuffer, $iRead, $BUFFER_SIZE = 4096

	If _Singleton($sTitle, 1) = 0 Then ; Das Master-Script läuft bereits - die Messwerte via NamedPipe senden!
		$bData = _GetCmdLine()
		If $bData Then
			$tDataBuffer = DllStructCreate("byte[" & BinaryLen($bData) & "]")
			DllStructSetData($tDataBuffer, 1, $bData)
			_NamedPipes_CallNamedPipe($sPipeName, DllStructGetPtr($tDataBuffer), BinaryLen($bData), 0, 0, $iRead)
		EndIf
	Else ; Das Master-Script starten

		Local $iInputStyle = BitOR($GUI_SS_DEFAULT_INPUT, $ES_READONLY)

		$hGui = GUICreate($sTitle & ' - Master-Script', 500, 430)
		GUISetBkColor(0x191970)
		MsgBox(64, '', '$hGui = ' & $hGui)

		GUICtrlCreateGroup('Messwerte', 10, 10, 480, 170)
		DllCall("UxTheme.dll", "int", "SetWindowTheme", "hwnd", GUICtrlGetHandle(-1), "wstr", "Explorer", "wstr", 0)
		GUICtrlSetColor(-1, 0xFF0000)
		GUICtrlSetBkColor(-1, 0xCDCDCD)

		_CreateLabel('Messwerte 1/5:', 15,  28, 130, 22, $g_aColors[0], $g_aColors[1])
		$aInputsMesswerte[0] = _CreateInput('', 150,  28, 335, 22, $iInputStyle, $g_aColors[0], $g_aColors[1])

		_CreateLabel('Messwerte 2/5:', 15,  58, 130, 22, $g_aColors[0], $g_aColors[1])
		$aInputsMesswerte[1] = _CreateInput('', 150,  58, 335, 22, $iInputStyle, $g_aColors[0], $g_aColors[1])

		_CreateLabel('Messwerte 3/5:', 15,  88, 130, 22, $g_aColors[0], $g_aColors[1])
		$aInputsMesswerte[2] = _CreateInput('', 150,  88, 335, 22, $iInputStyle, $g_aColors[0], $g_aColors[1])

		_CreateLabel('Messwerte 4/5:', 15, 118, 130, 22, $g_aColors[0], $g_aColors[1])
		$aInputsMesswerte[3] = _CreateInput('', 150, 118, 335, 22, $iInputStyle, $g_aColors[0], $g_aColors[1])

		_CreateLabel('Messwerte 5/5:', 15, 148, 130, 22, $g_aColors[2], $g_aColors[3])
		$aInputsMesswerte[4] = _CreateInput('', 150, 148, 335, 22, $iInputStyle, $g_aColors[2], $g_aColors[3])

		$g_idLabelStatus = _CreateLabel('Warte auf Messwerte...', 10, 188, 480, 22, $g_aColors[4], $g_aColors[5])

		$g_idMemo = GUICtrlCreateEdit('', 10, 220, 480, 200, BitOR($GUI_SS_DEFAULT_EDIT, $ES_READONLY))
		GUICtrlSetLimit(-1, 0x7FFFFFFF)
		GUICtrlSetFont(-1, 10, 500, 0, 'Courier New')
		GUICtrlSetColor(-1, $g_aColors[4])
		GUICtrlSetBkColor(-1, $g_aColors[5])

		GUISetState(@SW_SHOW, $hGui)

		$hPipe = _NamedPipes_CreateNamedPipe( _
			$sPipeName, _   ; Pipe name
			2, _            ; The pipe is bi-directional (duplex)
			2, _            ; Overlapped mode is enabled
			0, _            ; No security ACL flags
			1, _            ; Data is written to the pipe as a stream of messages
			1, _            ; Data is read from the pipe as a stream of messages
			0, _            ; Blocking mode is enabled
			1, _            ; Maximum number of instances
			$BUFFER_SIZE, _ ; Output buffer size
			$BUFFER_SIZE, _ ; Input buffer size
			0, _            ; Client time out
			0)              ; Default security attributes

		If $hPipe = -1 Then Exit MsgBox(48 + 262144, "NamedPipe", "Pipe konnte nicht erstellt werden!" & @CRLF & "Wahrscheinlich ist die Adresse schon vergeben.")

		Local $iAdlib = 0, $aMesswerte[1], $iMesswerteCounter = 0, $iTimerDiff = 0, $tOVERLAPPED = DllStructCreate($tagOVERLAPPED)

		$sData = _GetCmdLine(False)

		If $sData Then
			GUICtrlSetData($aInputsMesswerte[$iMesswerteCounter], $sData)
			$iMesswerteCounter = 1
			MemoWrite(StringFormat('Messwerte %i/5 wurden als Parameter übergeben!', $iMesswerteCounter))
			MemoWrite('--> ' & $sData)
		EndIf

		Do ; In dieser Schleife wartet das Master-Script auf Daten
			If $iMesswerteCounter > 0 Then
				If $iAdlib = 0 Then
					$iAdlib = AdlibRegister('_SetTimerStatus', 1000)
					$g_hTimer = TimerInit()
				EndIf
				$iTimerDiff = TimerDiff($g_hTimer)
			EndIf

			$tDataBuffer = DllStructCreate("byte[" & $BUFFER_SIZE & "]")
			_WinAPI_ReadFile($hPipe, DllStructGetPtr($tDataBuffer), $BUFFER_SIZE, $iRead, DllStructGetPtr($tOVERLAPPED))
			$sData = BinaryToString(DllStructGetData($tDataBuffer, 1), $SB_UTF8)
			$sData = StringLeft($sData, $iRead)

			If $iRead > 0 Then ; Wurden Messwerte gesendet?
				_NamedPipes_DisconnectNamedPipe($hPipe)
				If $sData = '/ClearMemo' Then
					GUICtrlSetData($g_idMemo, '')
					_NamedPipes_ConnectNamedPipe($hPipe, DllStructGetPtr($tOVERLAPPED))
					ContinueLoop
				EndIf

				MemoWrite(StringFormat('Messwerte %i/5 wurden gesendet!', $iMesswerteCounter + 1))
				MemoWrite('--> "' & $sData & '"')

				If $iTimerDiff <= $g_iDiffTime Then ; Timer ist noch im Limit!
					$iMesswerteCounter += 1

					GUICtrlSetData($aInputsMesswerte[$iMesswerteCounter - 1], $sData)

					If $iMesswerteCounter = 5 Then
						AdlibUnRegister('_SetTimerStatus')
						$iAdlib = 0
						$iMesswerteCounter = 0

						MemoWrite(@CRLF & '$iTimerDiff <= $iDiffTime - Messwerte werden verwertet!' & @CRLF)
						If StringInStr($sData, '|') Then
							$aMesswerte = StringSplit($sData, '|', 2)
						Else
							ReDim $aMesswerte[1]
							$aMesswerte[0] = $sData
						EndIf
						MemoWrite('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~')
						For $i = 0 To UBound($aMesswerte) -1 Step 1
							MemoWrite(StringFormat('$aMesswerte[%i] = %s', $i, $aMesswerte[$i]))
						Next
						MemoWrite('~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~' & @CRLF)

						; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
						; Mach was damit...
						; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
						; If $aMesswerte[0] > 100 Then ...
						; ...
						; ...
						; - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

						Sleep(3000) ; Damit man die Messwerte noch einen Moment in der GUI sehen kann.
						GUICtrlSetData($g_idLabelStatus, 'Warte auf Messwerte...')
						For $i = 0 To 4 Step 1
							GUICtrlSetData($aInputsMesswerte[$i], '')
						Next
					EndIf
				EndIf

				_NamedPipes_ConnectNamedPipe($hPipe, DllStructGetPtr($tOVERLAPPED))
			EndIf

			If $iMesswerteCounter > 0 And $iTimerDiff > $g_iDiffTime Then ; Timer ist über dem Limit!
					MemoWrite(@CRLF & '$iTimerDiff > $iDiffTime - Messwerte werden verworfen!' & @CRLF)
					AdlibUnRegister('_SetTimerStatus')
					$iAdlib = 0
					GUICtrlSetData($g_idLabelStatus, 'Warte auf Messwerte...')
					For $i = 0 To 4 Step 1
						GUICtrlSetData($aInputsMesswerte[$i], '')
					Next
					$iTimerDiff = 0
					$iMesswerteCounter = 0
					$g_hTimer = TimerInit()
			EndIf

		Until GUIGetMsg() = $GUI_EVENT_CLOSE

		_NamedPipes_DisconnectNamedPipe($hPipe)
		_NamedPipes_DisconnectNamedPipe($sPipeName)
		_WinAPI_CloseHandle($hPipe)
	EndIf
EndFunc   ;==>_Messwerte

Func _GetCmdLine($Binary = True)
	If $CMDLINE[0] = 0 Then Return False

	Local $vData = $Binary ? StringToBinary($CMDLINE[1]) : $CMDLINE[1]
	For $i = 2 To $CMDLINE[0] Step 1
		$vData &= $Binary ? StringToBinary('|' & $CMDLINE[$i]) : '|' & $CMDLINE[$i]
	Next

	Return $vData
EndFunc   ;==>_GetCmdLine

Func _SetTimerStatus()
	_GetTime()
	GUICtrlSetData($g_idLabelStatus, StringFormat("Timer: %02i:%02i:%02i:%02i", $g_iHour, $g_iMins, $g_iMins, $g_iSecs))
EndFunc   ;==>_SetTimerStatus

Func _GetTime()
	$g_iTicks = TimerDiff($g_hTimer)
	$g_iMiliSecs = StringRegExpReplace($g_iTicks, '.+\.(.+)', '\1')
	_TicksToTime(Int($g_iTicks), $g_iHour, $g_iMins, $g_iSecs)
	$g_sTime = StringFormat("%02i:%02i:%02i:%06i", $g_iHour, $g_iMins, $g_iSecs, $g_iMiliSecs)
EndFunc   ;==>_GetTime

; Gibt eine Zeile im Memo-Fenster aus
Func MemoWrite($sMessage)
	GUICtrlSetData($g_idMemo, $sMessage & @CRLF, 1)
EndFunc   ;==>MemoWrite

Func _CreateLabel($sText, $l, $t, $w, $h, $iColors, $iBkColors)
	Local $idLabel = GUICtrlCreateLabel($sText, $l, $t, $w, $h)
	GUICtrlSetColor(-1, $iColors)
	GUICtrlSetBkColor(-1, $iBkColors)
	GUICtrlSetFont(-1, 12, 900)
	Return $idLabel
EndFunc

Func _CreateInput($sText, $l, $t, $w, $h, $iStyle, $iColors, $iBkColors)
	Local $idInput = GUICtrlCreateInput($sText, $l, $t, $w, $h, $iStyle)
	GUICtrlSetColor(-1, $iColors)
	GUICtrlSetBkColor(-1, $iBkColors)
	GUICtrlSetFont(-1, 11, 500)
	Return $idInput
EndFunc
